---
- name: Build "golden" image
  hosts: localhost
  tasks:
    - name: Get omnibus version
      command: bundle exec knife role attribute get {{env}}{{ '' if stage == 'main' else '-' + stage }}-omnibus-version omnibus-gitlab.package.version
      args:
        chdir: "{{ chef_repo_path }}"
      register: omnibus_version_cmd

    - set_fact:
        omnibus_version_label_value: "{{ omnibus_version_cmd.stdout | replace('.', '_') }}"

    - name: Look for existing image
      command: gcloud --project {{ gcp_project }} compute images list --filter="labels.omnibus_package_version:{{ omnibus_version_label_value }}" --format="value(name)"
      register: image_name

    - name: Build image
      import_tasks: trigger_build_pipeline.yml
      when: image_name.stdout == ""
      vars:
        omnibus_version: "{{ omnibus_version_cmd.stdout }}"

    - name: Get image name
      command: gcloud --project {{ gcp_project }} compute images list --filter="labels.omnibus_package_version:{{ omnibus_version_label_value }}" --format="value(name)"
      register: image_name

    - name: Get image tested status
      command: gcloud --project {{ gcp_project }} compute images list --filter="labels.omnibus_package_version:{{ omnibus_version_label_value }}" --format="value(labels.tested)"
      register: image_tested

    - name: Prompt for MR
      pause:
        prompt: "Target base image: '{{ image_name.stdout }}'. Create an MR to update the base images of packertest and the target modules to it"

- name: Test image
  import_playbook: packertest.yml
  vars:
    omnibus_version: "{{ hostvars['localhost']['omnibus_version_cmd'].stdout }}"
  when: hostvars['localhost']['image_tested'].stdout != "true"

- name: Mark the image as tested
  hosts: localhost
  tasks:
    - name: Set tested label
      command: gcloud --project {{ gcp_project }} compute images add-labels {{ image_name.stdout }} --labels="tested=true"
